<template>
  <q-page padding>
    <q-dialog v-model="ownerSecretDialog">
      <q-card>
        <q-card-section>
          <div class-="text-h6">Take a screenshot, keep it safe and do not share it with anyone.</div>
          <div class="text-h4 text-center">{{ passcode }}</div>
        </q-card-section>

        <q-card-section class="q-pt-none">
          The alphanumeric combination above is your passcode that will be required to view requests and to delete your entry.
        </q-card-section>

        <q-card-actions align="right">
          <q-btn flat label="OK" color="primary" @click="$router.push('/')" v-close-popup />
        </q-card-actions>
      </q-card>
    </q-dialog>
    <div class="column items-center">
      <span class="text-h3 text-center">Add a new cylinder</span>
      <q-form class="q-gutter-md" @submit="addNewO2Cylinder">
        <span class="row text-h5 q-pt-md">O2 Cylinder owner details</span>
        <div class="row justify-center q-gutter-md">
          <q-input
            v-model="name"
            label="Owner's name"
            :rules="[ val => val && val.length > 0 || 'Please enter the name.']"
          />

          <q-input
            v-model="phone"
            label="Owner's phone"
            :rules="[ val => val && val.length === 10 || 'Please enter the phone.']"
          >
            <template v-slot:prepend>
              <span class="text-p">+91</span>
            </template>
          </q-input>
        </div>

        <span class="row text-h5 q-pt-md">Cylinder details</span>
        <div class="row justify-center q-gutter-md">
          <q-input
            v-model.number="quantity"
            label="Capacity (in Litres)"
            type="number"
          />

          <q-select
            use-input
            :behavior="$q.platform.is.ios === true ? 'dialog' : 'menu'"
            v-model="cylinderType"
            :options="cylinderTypes"
            label="Cylinder's type"
          />

          <q-select
            use-input
            :behavior="$q.platform.is.ios === true ? 'dialog' : 'menu'"
            v-model="cylinderCondition"
            :options="cylinderConditions"
            label="Cylinder's condition"
            :rules="[ val => val && val.length > 0 || 'Please enter the requirement.']"
          />
        </div>

        <span class="row text-h5 q-pt-md">Location</span>
        <div class="row justify-center q-gutter-md">
          <q-select
            use-input
            :behavior="$q.platform.is.ios === true ? 'dialog' : 'menu'"
            v-model="state"
            :options="states"
            label="State"
            :rules="[ val => val && val.isoCode.length > 0 || 'Please choose a state.']"
          />

          <q-select
            use-input
            :behavior="$q.platform.is.ios === true ? 'dialog' : 'menu'"
            v-model="city"
            :options="cities"
            label="City"
            :rules="[ val => val && val.length > 0 || 'Please choose a city.']"
          />

          <q-input
            v-model="pincode"
            label="Pincode"
            :rules="[ val => val && val.length > 0 || 'Please enter the phone.']"
          />
        </div>

        <div class="row justify-end">
          <q-btn
            color="primary"
            label="Submit"
            type="submit"
          />
        </div>
      </q-form>
    </div>
  </q-page>
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api'
import csc from 'country-state-city'

export default defineComponent({
  name: 'PageNewCylinder',
  data () {
    return {
      name: '',
      phone: '',
      quantity: '',
      cylinderType: '',
      cylinderTypes: [
        'CAN',
        'Concentrator',
        'B',
        'D',
        'E',
        'F',
        'G',
        'H',
        'M',
        'Unknown'
      ],
      cylinderCondition: '',
      cylinderConditions: [
        'Filled',
        'Partially filled',
        'Empty',
        'Damaged'
      ],
      state: {
        label: '',
        value: '',
        isoCode: ''
      },
      city: '',
      pincode: '',
      passcode: '',
      ownerSecretDialog: false
    }
  },

  computed: {
    states () {
      return csc.getStatesOfCountry('IN').map((item) => {
        return {
          label: item.name,
          value: item.name,
          isoCode: item.isoCode
        }
      })
    },

    cities () {
      if (this.state) {
        return csc.getCitiesOfState('IN', this.state.isoCode).map((item) => {
          return item.name
        })
      } else {
        return []
      }
    }
  },

  methods: {
    addNewO2Cylinder () {
      this.addNewO2()
        .then((response: {data: {passcode: string}}) => {
          this.passcode = response.data.passcode
          this.clearForm()
          this.ownerSecretDialog = true
          this.notify('Added an unused cylinder. Resetting form.', 'info')
        })
        .catch((error: {response: {data: {message: string}}}) => {
          console.log(error)
          this.notify(error.response.data.message, 'negative')
        })
    },

    addNewO2 () {
      const payload = {
        owner_name: this.name,
        phone: this.phone,
        quantity: this.quantity,
        cylinder_type: this.cylinderType,
        condition: this.cylinderCondition,
        state: this.state.value,
        city: this.city,
        pincode: parseInt(this.pincode)
      }

      return this.$axios.post('/api/cylinders', payload)
    },

    clearForm () {
      this.name = ''
      this.phone = ''
      this.quantity = ''
      this.cylinderType = ''
      this.cylinderCondition = ''
      this.state = ''
      this.city = ''
      this.pincode = ''
    },

    notify (msg: string, color: string) {
      this.$q.notify({
        // message: 'Added an unused cylinder. Resetting form.',
        // color: 'info'
        message: msg,
        color: color
      })
    }
  }
})
</script>
